"""
Django settings for django_example project.

Generated by 'django-admin startproject' using Django 3.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path
from django.core.management.utils import get_random_secret_key
import os
import json


# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!

def generate_secret_key (filepath):
    secret_file = open(filepath, "w")
    secret = "SECRET_KEY = " + "\""+ get_random_secret_key() + "\"" + "\n"
    secret_file.write(secret)
    secret_file.close()

if os.environ.get("DJANGO_SECRET_KEY") != None and os.environ.get("DJANGO_SECRET_KEY") != "":
    SECRET_KEY = os.environ["DJANGO_SECRET_KEY"]
else:
    try:
        # ignore missing import error
        from .secret_key import SECRET_KEY # type: ignore 
    except ImportError:
        SETTINGS_DIR = os.path.abspath(os.path.dirname(__file__))
        generate_secret_key(os.path.join(SETTINGS_DIR, 'secret_key.py'))
        # ignore missing import error
        from .secret_key import SECRET_KEY # type: ignore

# def get_sm_secret(secret_arn):
#     boto_session = boto3.session.Session()
#     sm_client = boto_session.client('secretsmanager')
#     sm_secret_value_response = sm_client.get_secret_value(
#         SecretId=secret_arn
#     )
#     return sm_secret_value_response["SecretString"]

# set environment variables from CDK deployment if needed (cdk bundles these secrets from rds)
if os.environ.get("RDS_SECRETS") != None:
    rds_secrets = json.loads(os.environ["RDS_SECRETS"])
    os.environ["DJANGO_DB_NAME"] = rds_secrets["dbname"]
    os.environ["DJANGO_DB_USER"] = rds_secrets["username"]
    os.environ["DJANGO_DB_PASS"] = rds_secrets["password"]
    os.environ["DJANGO_DB_HOST"] = rds_secrets["host"]
    os.environ["DJANGO_DB_PORT"] = str(rds_secrets["port"])

# SECURITY WARNING: don't run with debug turned on in production!
# TODO Does this handle all cases?
DEBUG = os.environ.get("DJANGO_DEBUG") == "true"

# TODO can we trim this down easily? For now using security group should be fine, do that first, at least.
ALLOWED_HOSTS = ['*']

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'pages.apps.PagesConfig'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = os.environ.get("DJANGO_PROJECT_NAME") + '.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            str(BASE_DIR.joinpath('templates')),
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = os.environ.get("DJANGO_PROJECT_NAME") + '.wsgi.application'

# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases


DATABASES = {
    'default': {
       'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': os.environ.get("DJANGO_DB_NAME"),
        'USER': os.environ.get("DJANGO_DB_USER"),
        'PASSWORD': os.environ.get("DJANGO_DB_PASS"),
        'HOST': os.environ.get("DJANGO_DB_HOST"),
        'PORT': os.environ.get("DJANGO_DB_PORT"),
        'DISABLE_SERVER_SIDE_CURSORS': True, 
    }
}



# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.1/howto/static-files/

STATIC_URL = '/static/'

# likely needed when running collect static
STATIC_ROOT = str(BASE_DIR.joinpath('static_root'))

STATICFILES_DIRS = [
    str(BASE_DIR.joinpath('static'))
    ]

LOGIN_REDIRECT_URL = '/'
LOGOUT_REDIRECT_URL = '/'

PHONENUMBER_DB_FORMAT = 'NATIONAL'

DEFAULT_AUTO_FIELD = 'django.db.models.AutoField'